/* 
 * This file is part of the Echo Point Project.  This project is a collection
 * of Components that have extended the Echo Web Application Framework.
 *
 * EchoPoint is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * EchoPoint is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Echo Point; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//---------------------------------------------------------------------------------------
// Positions the dialog "cover" div, with its coverUri and the dialog content element
//---------------------------------------------------------------------------------------
function g_epdlg_position(coverId, coverUri, dialogId, contentId, positionContent) {
	var elemOver = getElementById(coverId);
	if (elemOver == null) return;

	var elemDialog = getElementById(dialogId);
	if (elemDialog == null) return;

	elemOver.htmlE.style.width = document.body.scrollWidth;
	elemOver.htmlE.style.height = document.body.scrollHeight;

	if (positionContent) {


		var elemContent = getElementById(contentId);
		if (elemContent == null) return;

		var cw = document.body.clientWidth;
		var ch = document.body.clientHeight;
	
		var cl = document.body.scrollLeft;
		var ct = document.body.scrollTop;
	
		var ew;
		var eh;

		ew = elemDialog.htmlE.scrollWidth;
		eh = elemDialog.htmlE.scrollHeight;

		ew = elemContent.htmlE.scrollWidth;
		eh = elemContent.htmlE.scrollHeight;

	
		if (cw != null && ch != null && cl != null && ct != null && ew != null && ch != null) {
			var l = cl + (cw/2) - (ew /2);
			var t = ct + (ch/2) - (eh /2);
			if (l >= 0)
				elemDialog.htmlE.style.left  = l;
			if (t >= 0)
				elemDialog.htmlE.style.top   = t;
		}
	}

	if (browser.isIE) {
		epbe_hideSelectFieldsUnder(dialogId);
	}
	elemDialog.htmlE.style.visibility = 'visible';
}

//---------------------------------------------------------------------------------------
// function called when the mouse moves
//---------------------------------------------------------------------------------------
function epdlg_OnDrag(mouseCapture, eventType, event) {
	epbe_defaultOnDrag(mouseCapture, eventType, event);
	//
	// make sure we dont drag the top and left of the dialog beyond
	// 0.  Otherwise the user may get into a siutation where
	// they can drag it back.
	//
	var e = mouseCapture.dragE;
	if (e.getY() < 0)
		e.setY(0);
	if (e.getX() < 0)
		e.setX(0);
	
	var htmlId = mouseCapture.dragContext;
	epdlg_saveState(mouseCapture.target.id,htmlId);
}

//---------------------------------------------------------------------------------------
// Save the state of the Dialog
//---------------------------------------------------------------------------------------
function epdlg_saveState(dialogId, contentId) {
	var sbpos = '';
	var dlg = getElementById(dialogId);
	var content = getElementById(contentId);
	if (dlg != null && content != null) {

		sbpos += content.htmlE.scrollLeft + "," + content.htmlE.scrollTop;
		sbpos += '&';
		sbpos += dlg.getX() + "," + dlg.getY();

		if (E_setParameter)
			E_setParameter(contentId,sbpos);
	}
}

//---------------------------------------------------------------------------------------
// Beep baby beep
//---------------------------------------------------------------------------------------
function epdlg_beepIf(event,htmlId,beepId,waveUrl) {
	var targetHtmlE = null;
	if (browser.isIE)
		targetHtmlE = window.event.srcElement;
	else
		targetHtmlE = event.target;
			
	if (targetHtmlE.id == htmlId) {		
		ep_beep(beepId,waveUrl);
	}
}


