/* 
 * This file is part of the Echo Point Project.  This project is a collection
 * of Components that have extended the Echo Web Application Framework.
 *
 * EchoPoint is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * EchoPoint is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Echo Point; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 *
 *  This script is used to implement the SpinField client side support
 *
 */

//---------------------------------------------
//---------------------------------------------
function ep_spinSaveState(sfE,id) {
	if (E_setParameter)
		E_setParameter(id,sfE.value);
}

//---------------------------------------------
//---------------------------------------------
function ep_spinDown(sfE,id) {
	var sfValue = sfE.value;
	if (this.type == 1) {
		var intValue = parseInt(sfValue);
		if (isNaN(intValue))
			return;
		if (intValue > this.min) {
			sfE.value = intValue - 1;
		} else if (this.wrap) {
			sfE.value = this.max;
		}
	}

	if (this.type == 2) {
		// find out current string
		for (i = 0; i < this.list.length; i++) {
			if (this.list[i] == sfValue && i > 0) {
				sfE.value = this.list[i-1];	
				ep_spinSaveState(sfE,id);
				return;
			}
		}
		if (this.wrap)
			sfE.value = this.list[this.list.length-1];	
	}
	ep_spinSaveState(sfE,id);
}

//---------------------------------------------
//---------------------------------------------
function ep_spinUp(sfE,id) {
	var sfValue = sfE.value;
	if (this.type == 1) {
		var intValue = parseInt(sfValue);
		if (isNaN(intValue))
			return;
		if (intValue < this.max) {
			sfE.value = intValue + 1;
		} else if (this.wrap) {
			sfE.value = this.min;
		}
	}
	if (this.type == 2) {
		// find out current string
		for (i = 0; i < this.list.length; i++) {
			if (this.list[i] == sfValue && i < this.list.length-1) {
				sfE.value = this.list[i+1];	
				ep_spinSaveState(sfE,id);
				return;
			}
		}
		if (this.wrap)
			sfE.value = this.list[0];	
	}
	ep_spinSaveState(sfE,id);
}

//---------------------------------------------
//
// type :   1 = integer
// 			2 = string list
//---------------------------------------------
function EchoSpinField(min, max, wrap, listStr) {
	this.type = 1; 
	if (listStr != null)
		this.type = 2; 
	this.max = max;
	this.min = min;
	this.wrap = wrap;
	if (listStr != null)
		this.list = listStr.split('|');
	else
		this.list = new Array(0);

	this.spinUp = ep_spinUp;
	this.spinDown = ep_spinDown;
}
