/*
 * This file is part of the SOAFaces Project (hereinafter "SOAFaces").
 * Copyright (C) 2006 Grand Logic, Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package org.soafaces.bundle.client.ui;

import com.google.gwt.user.client.ui.Panel;

/**
 * <p>
 * This class should be subclassed to implement the GUI that will be used
 * to display the input/output JavaBean associated with a Tasklet after it runs.
 * This is used as the primary GUI to view the Tasklet's output/output
 * JavaBean after a job has started running or has finished running.
 * </p>
 *
 * <p>
 * This class is primarly used as a type marker to let the container
 * know this class is primarily intended for viewing the output JavaBean
 * of a Tasklet.
 * </p>
 * 
 * @author Sam Taha
 * 
 */
@Deprecated
public abstract class OutputViewer extends BaseIOViewer {

  /**
   * Implement this to create all the widgets that will be housed in this
   * top level container. This is called only once to populte the UI.
   * 
   */
  protected abstract void buildUI();
  
  /**
   * This can return <code>RootPanel.get()</code> or any other panel you want to house your UI.
   * @return
   */
  public abstract Panel getMainPanel();
}
